All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
AmoebaWcaDispersionForce Class Reference

This class implements a nonbonded interaction between pairs of particles typically used along with AmoebaGeneralizedKirkwoodForce as part of an implicit solvent model. More...

`#include <AmoebaWcaDispersionForce.h>`

Inheritance diagram for AmoebaWcaDispersionForce:

## Public Member Functions

| AmoebaWcaDispersionForce ()
| Create an AmoebaWcaDispersionForce. More...
int | getNumParticles () const
| Get the number of particles. More...
void | setParticleParameters (int particleIndex, double radius, double epsilon)
| Set the force field parameters for a WCA dispersion particle. More...
void | getParticleParameters (int particleIndex, double &radius, double &epsilon) const
| Get the force field parameters for a WCA dispersion particle. More...
int | addParticle (double radius, double epsilon)
| Set the force field parameters for a WCA dispersion particle. More...
void | updateParametersInContext (Context &context)
| Update the per-particle parameters in a Context to match those stored in this Force object. More...
double | getEpso () const
double | getEpsh () const
double | getRmino () const
double | getRminh () const
double | getAwater () const
double | getShctd () const
double | getDispoff () const
double | getSlevy () const
void | setEpso (double inputValue)
void | setEpsh (double inputValue)
void | setRmino (double inputValue)
void | setRminh (double inputValue)
void | setAwater (double inputValue)
void | setShctd (double inputValue)
void | setDispoff (double inputValue)
void | setSlevy (double inputValue)
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class implements a nonbonded interaction between pairs of particles typically used along with AmoebaGeneralizedKirkwoodForce as part of an implicit solvent model.

To use it, create an AmoebaWcaDispersionForce object then call addParticle() once for each particle. After a particle has been added, you can modify its force field parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaWcaDispersionForce | ( |  | ) |

Create an AmoebaWcaDispersionForce.

## Member Function Documentation

int addParticle | ( | double | radius,
|  | double | epsilon
| ) |  |

Set the force field parameters for a WCA dispersion particle.

Parameters

  radius | radius
  epsilon | epsilon

Returns
  index of added particle

ForceImpl* createImpl | ( |  | ) | const

protectedvirtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

double getAwater | ( |  | ) | const

double getDispoff | ( |  | ) | const

double getEpsh | ( |  | ) | const

double getEpso | ( |  | ) | const

int getNumParticles | ( |  | ) | const

inline

Get the number of particles.

void getParticleParameters | ( | int | particleIndex,
|  | double & | radius,
|  | double & | epsilon
| ) |  | const

Get the force field parameters for a WCA dispersion particle.

Parameters

  particleIndex | the particle index
  radius | radius
  epsilon | epsilon

double getRminh | ( |  | ) | const

double getRmino | ( |  | ) | const

double getShctd | ( |  | ) | const

double getSlevy | ( |  | ) | const

void setAwater | ( | double | inputValue | ) |

void setDispoff | ( | double | inputValue | ) |

void setEpsh | ( | double | inputValue | ) |

void setEpso | ( | double | inputValue | ) |

void setParticleParameters | ( | int | particleIndex,
|  | double | radius,
|  | double | epsilon
| ) |  |

Set the force field parameters for a WCA dispersion particle.

Parameters

  particleIndex | the particle index
  radius | radius
  epsilon | epsilon

void setRminh | ( | double | inputValue | ) |

void setRmino | ( | double | inputValue | ) |

void setShctd | ( | double | inputValue | ) |

void setSlevy | ( | double | inputValue | ) |

void updateParametersInContext | ( | Context & | context | ) |

Update the per-particle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

The only information this method updates is the values of per-particle parameters. All other aspects of the Force are unaffected and can only be changed by reinitializing the Context.

bool usesPeriodicBoundaryConditions | ( |  | ) | const

inlinevirtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  true if nonbondedMethod uses PBC and false otherwise

Reimplemented from Force.

The documentation for this class was generated from the following file:

- AmoebaWcaDispersionForce.h